/*
 *    BerryBasketModel.java
 *    Copyright (C) 2001 New Zealand Digital Library Project
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package org.nzdl.gsdl.SimpleGraphicalClient;


import java.util.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.table.*; 
import java.awt.*;


class BerryBasketModel extends AbstractTableModel {

    private ArrayList columnTitles;
    private ArrayList berryBasket;

    private String DOCUMENT = "Document";
    private String DATE = "Date";
 
 
    public BerryBasketModel()
    {
	super();
	berryBasket = new ArrayList();
	columnTitles = new ArrayList();
	columnTitles.add(DOCUMENT);
	//columnTitles.add("User");
	columnTitles.add(DATE);
    }

    public void add(Berry berry) {
	System.out.println("adding to BerryBasketModel: "  + berry.toString());
	berryBasket.add(0, berry);
	fireTableRowsInserted(0,0);
    }
	
    public int getColumnCount() { 
	return columnTitles.size();
    }

    public String getColumnName(int column) {
	return (String) columnTitles.get(column);
    }

    public int getRowCount() {
	return berryBasket.size();
    }
	
    public Object getValueAt(int row, int column) { 
	// get Berry object
	// extract document title (say), person, date info from Berry object
	// depending on column number
	// column reordering shouldn't matter, all
	// gets dealt with automatically

	Berry berry = (Berry) berryBasket.get(row);

	if (column == columnTitles.indexOf(DOCUMENT)) return berry.toString();

	if (column == columnTitles.indexOf(DATE)) return berry.getDateAdded();

	// shouldn't get here but display something anyway
	return "row" + row + "col" + column;
    }
	
}
